// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "TransparentDialogBar.h"
#include "gdGridCtrl.h"
#include "rlManager.h"
#include "rlMemoryChannelArray.h"

#include "rlProgressTarget.h"
#include "TransferProgressDialog.h"

#define CHANNEL_LIST_COLUMN_NUMBER			0
#define CHANNEL_LIST_COLUMN_FREQUENCY		1
#define CHANNEL_LIST_COLUMN_DESCRIPTION		2
#define CHANNEL_LIST_COLUMN_CARNUMBER		3
#define CHANNEL_LIST_COLUMN_DELAY			4
#define CHANNEL_LIST_COLUMN_LOCKOUT			5
#define CHANNEL_LIST_COLUMN_PRIORITY		6

// REMOVE
#include "rlSerialLink.h"

class CMainFrame : public CFrameWnd, rlProgressTarget
{
	public:
		CMainFrame ();

	protected: 
		DECLARE_DYNAMIC (CMainFrame)

	// Attributes
	public:

	// Operations
	public:

	// Overrides
	public:
		virtual BOOL PreCreateWindow (CREATESTRUCT& cs);
		virtual BOOL OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

		virtual void OnSetRange (const int, const int);
		virtual void OnSetPosition (const int);

	// Implementation
	public:
		virtual ~CMainFrame();
		#ifdef _DEBUG
			virtual void AssertValid() const;
			virtual void Dump(CDumpContext& dc) const;
		#endif

	protected:
		CStatusBar	m_wndStatusBar;
		CToolBar	m_wndToolBar;
		CReBar		m_wndReBar;
		//CTransparentDialogBar	m_dlgModulesBar;
		//CTransparentDialogBar	m_dlgBanksBar;
		gdGridCtrl	m_wndChannelList;

		CTransferProgressDialog *m_pTransferProgressDialog;

		rlManager	m_RadioLinkManager;
		rlMemoryChannelArray m_MemoryChannelArray;

		CString		m_strFileName;

		const CString GetItemString (const int, const int);
		void SetItemString (const int, const int, const CString);

		// REMOVE
		rlSerialLink m_SerialLink;

	// Generated message map functions
	protected:
		afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
		afx_msg void OnSetFocus (CWnd *pOldWnd);
		afx_msg void OnGetDispInfo (NMHDR *pNotifyStruct, LRESULT *lResult);
		afx_msg void OnEndLabelEdit (NMHDR *pNotifyStruct, LRESULT *lResult);

	public:
		afx_msg void OnFileNew();
		afx_msg void OnTransferModules();
		afx_msg void OnTransferUploadAll();
		afx_msg void OnTransferUploadSelected();
		afx_msg void OnFileOpen();
		afx_msg void OnFileSave();
		afx_msg void OnFileSaveAs();
		afx_msg void OnViewDebugMessages();
		afx_msg void OnEditDelete();
		afx_msg void OnUpdateUIItemSelected(CCmdUI *pCmdUI);

	DECLARE_MESSAGE_MAP()
};


