#pragma once

#include "gdGridCtrl.h"

#define CHANNEL_LIST_COLUMN_NUMBER			0
#define CHANNEL_LIST_COLUMN_FREQUENCY		1
#define CHANNEL_LIST_COLUMN_DESCRIPTION		2
#define CHANNEL_LIST_COLUMN_CARNUMBER		3
#define CHANNEL_LIST_COLUMN_DELAY			4
#define CHANNEL_LIST_COLUMN_LOCKOUT			5
#define CHANNEL_LIST_COLUMN_PRIORITY		6

// CChannelListView view

class CChannelListView : public CView
{
	DECLARE_DYNCREATE(CChannelListView)

	protected:
		CChannelListView();           // protected constructor used by dynamic creation
		virtual ~CChannelListView();

	public:
		virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
		virtual void OnDraw(CDC* pDC);      // overridden to draw this view
		afx_msg void OnSize(UINT nType, int cx, int cy);
		afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);

		#ifdef _DEBUG
			virtual void AssertValid() const;
			virtual void Dump(CDumpContext& dc) const;
		#endif

	protected:
		virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
		virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
		virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

		afx_msg void OnGetDispInfo (NMHDR *pNotifyStruct, LRESULT *lResult);
		afx_msg void OnEndLabelEdit (NMHDR *pNotifyStruct, LRESULT *lResult);

		const CString GetItemString (const int, const int);
		void SetItemString (const int, const int, const CString);

		gdGridCtrl m_GridCtrl;

	DECLARE_MESSAGE_MAP()

	virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
};


