#include "StdAfx.h"
#include "libraryfolder.h"

CLibraryFolder::CLibraryFolder (CLibraryFolder *pParentFolder, CString strFolderName) : CLibraryItem (pParentFolder, strFolderName)
{
}

CLibraryFolder::~CLibraryFolder(void)
{
	DeleteAllChildItems ();
}

void CLibraryFolder::SetTreeCtrl (CTreeCtrl *pTreeCtrl)
{
	CLibraryItem::SetTreeCtrl (pTreeCtrl);

	for (int x = 0; x < GetChildCount (); x++)
	{
		GetChild (x)->SetTreeCtrl (pTreeCtrl);
	}
}

const int CLibraryFolder::GetChildCount (void)
{
	return static_cast <int> (m_ChildItems.GetCount ());
}

CLibraryItem *CLibraryFolder::GetChild (const int nChildIndex)
{
	return m_ChildItems.GetAt (nChildIndex);
}

CLibraryItem *CLibraryFolder::CreateChildItem (CString strItemName)
{
	// create the new child item object on the heap
	CLibraryItem *pNewLibraryItem = DEBUG_NEW CLibraryItem (this, strItemName);

	// add the item to our list of child items
	m_ChildItems.Add (pNewLibraryItem);

	pNewLibraryItem->SetTreeCtrl (m_pTreeCtrl);

	// return a pointer to the new item
	return pNewLibraryItem;
}

CLibraryFolder *CLibraryFolder::CreateChildFolder (CString strFolderName)
{
	// create the new child item object on the heap
	CLibraryFolder *pNewLibraryFolder = DEBUG_NEW CLibraryFolder (this, strFolderName);

	// add the item to our list of child items
	m_ChildItems.Add (pNewLibraryFolder);

	// return a pointer to the new item
	return pNewLibraryFolder;
}

void CLibraryFolder::DeleteChild (const int nChildIndex)
{
	// get a pointer to the item before we remove it from our list
	CLibraryItem *pLibraryItem = GetChild (nChildIndex);

	// remove the item from the list
	m_ChildItems.RemoveAt (nChildIndex);

	// we created the item on the heap so we must delete it
	delete pLibraryItem;
	pLibraryItem = NULL;
}

void CLibraryFolder::DeleteChild (CLibraryItem *pLibraryItem)
{
	for (int x = 0; x < GetChildCount (); x++)
	{
		if (GetChild (x) == pLibraryItem)
		{
			DeleteChild (x);
		}
	}
}

void CLibraryFolder::DeleteAllChildItems (void)
{
	for (int x = 0; x < GetChildCount (); x++)
	{
		DeleteChild (x);
	}
}
