#include "StdAfx.h"
#include "libraryitem.h"

#include "LibraryFolder.h"


CLibraryItem::CLibraryItem (CLibraryFolder *pParentFolder, CString strItemName)
{
	m_pTreeCtrl = NULL;
	m_hTreeItem = 0;
	m_pParentFolder = NULL;

	SetParentFolder (pParentFolder);
	SetItemName (strItemName);
}

CLibraryItem::~CLibraryItem (void)
{
}

void CLibraryItem::SetTreeCtrl (CTreeCtrl *pTreeCtrl)
{
	if (pTreeCtrl == NULL) return;

	m_pTreeCtrl = pTreeCtrl;

	if (GetParentFolder () == NULL)
	{
		m_hTreeItem = pTreeCtrl->InsertItem (m_strItemName);
	}
	else
	{
        m_hTreeItem = pTreeCtrl->InsertItem (m_strItemName, GetParentFolder ()->GetTreeItemHandle ());
	}
}

HTREEITEM CLibraryItem::GetTreeItemHandle (void)
{
	return m_hTreeItem;
}

CLibraryFolder *CLibraryItem::GetParentFolder (void)
{
	return m_pParentFolder;
}

void CLibraryItem::SetParentFolder (CLibraryFolder *pParentFolder)
{
	m_pParentFolder = pParentFolder;
}

CString CLibraryItem::GetItemName (void)
{
	return m_strItemName;
}

void CLibraryItem::SetItemName (const CString strItemName)
{
	m_strItemName = strItemName;
}
