// LibraryTreeView.cpp : implementation file
//

#include "stdafx.h"
#include "ProLink.h"
#include "LibraryTreeView.h"

#include "ProLinkDocument.h"

// CLibraryTreeView

IMPLEMENT_DYNCREATE(CLibraryTreeView, CTreeView)

CLibraryTreeView::CLibraryTreeView()
{
}

CLibraryTreeView::~CLibraryTreeView()
{
}

BEGIN_MESSAGE_MAP(CLibraryTreeView, CTreeView)
	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()


// CLibraryTreeView diagnostics

#ifdef _DEBUG
void CLibraryTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CLibraryTreeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG


// CLibraryTreeView message handlers

BOOL CLibraryTreeView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style |= TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;

	return CTreeView::PreCreateWindow(cs);
}

BOOL CLibraryTreeView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
	if (!CTreeView::Create (lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext)) return FALSE;

	m_pTreeCtrl = &GetTreeCtrl ();

	/*
	((CProLinkDocument *) m_pDocument)->GetLibraryRoot ()->SetTreeCtrl (m_pTreeCtrl);

	m_pTreeCtrl->Expand (((CProLinkDocument *) m_pDocument)->GetLibraryRoot ()->GetTreeItemHandle (), TVE_EXPAND);
	*/

	return TRUE;
}

void CLibraryTreeView::OnContextMenu (CWnd* pWnd, CPoint point)
{
	CPoint ptClientPoint;
	CPoint ptScreenPoint;

	HTREEITEM hTreeItem;

	if (point.x == 0xffffffff && point.y == 0xffffffff)
	{
		hTreeItem = m_pTreeCtrl->GetSelectedItem ();

		if (hTreeItem != NULL)
		{
			CRect ItemRect;
			m_pTreeCtrl->GetItemRect (hTreeItem, ItemRect, TRUE);

			ptClientPoint.x = ItemRect.left;
			ptClientPoint.y = ItemRect.bottom;

			ptScreenPoint = ptClientPoint;
			ClientToScreen (&ptScreenPoint);
		}
		else
		{
			CRect ClientRect;
			GetClientRect (&ClientRect);

			ptClientPoint.x = ClientRect.left;
			ptClientPoint.y = ClientRect.top;

			ptScreenPoint = ptClientPoint;
			ClientToScreen (&ptScreenPoint);
		}
	}
	else
	{
		ptScreenPoint = point;

		ptClientPoint = point;
		ScreenToClient (&ptClientPoint);

		// find out which item was clicked on
		hTreeItem = m_pTreeCtrl->HitTest (ptClientPoint, NULL);
	}

	// only show the context menu if a tree item was clicked on
	//if (hTreeItem != NULL)
	{
		// make sure the tree item is selected
		m_pTreeCtrl->Select (hTreeItem, TVGN_CARET);

		// load the menu
		CMenu mnuContext;
		mnuContext.LoadMenu (IDR_CONTEXT_LIBRARY_ITEM);

		mnuContext.GetSubMenu (0)->TrackPopupMenu (TPM_LEFTALIGN, ptScreenPoint.x, ptScreenPoint.y, pWnd);
	}
}

void CLibraryTreeView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
	/*
	m_pTreeCtrl = &GetTreeCtrl ();
	((CProLinkDocument *) m_pDocument)->GetLibraryRoot ()->SetTreeCtrl (m_pTreeCtrl);
	*/
}
