// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ProLink.h"
#include "MainFrm.h"

#include "rlManagerModulesDlg.h"

#include "DelimitedTextFile.h"
#include "DelimitedTextFileImportDlg.h"
#include "Table.h"

#include "TransferProgressDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE (CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP (CMainFrame, CFrameWnd)
	ON_WM_CREATE ()

	ON_WM_SETFOCUS ()

	//ON_COMMAND (ID_FILE_NEW, OnFileNew)
	//ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)

	//ON_COMMAND(ID_EDIT_DELETE, OnEditDelete)
	//ON_UPDATE_COMMAND_UI(ID_EDIT_DELETE, OnUpdateUIItemSelected)

	ON_COMMAND(ID_VIEW_DEBUGMESSAGES, OnViewDebugMessages)

	//ON_COMMAND (ID_TRANSFER_MODULES, OnTransferModules)
	//ON_COMMAND(ID_TRANSFER_UPLOADALL, OnTransferUploadAll)
	//ON_COMMAND(ID_TRANSFER_UPLOADSELECTED, OnTransferUploadSelected)
	//ON_UPDATE_COMMAND_UI(ID_TRANSFER_UPLOADSELECTED, OnUpdateUIItemSelected)

	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP_INTERFACECABLES, OnHelpInterfaceCables)
	ON_COMMAND(ID_HELP_PROLINKWEBSITE, OnHelpProLinkWebsite)
END_MESSAGE_MAP ()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pTransferProgressDialog = NULL;

	BOOL bFirstRun = AfxGetApp ()->GetProfileInt (_T(""), _T("First Run"), TRUE);

	if (bFirstRun)
	{
		OnTransferModules ();
		AfxGetApp ()->WriteProfileInt (_T(""), _T("First Run"), FALSE);
	}

}

CMainFrame::~CMainFrame()
{
	if (m_pTransferProgressDialog != NULL)
	{
		m_pTransferProgressDialog->DestroyWindow ();
		delete m_pTransferProgressDialog;
	}
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = ::AfxRegisterWndClass (0, 0, 0, AfxGetApp ()->LoadIcon (IDR_MAINFRAME));

	return TRUE;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1) return -1;

	// create the main tool bar
	if (!m_wndToolBar.CreateEx (this, TBSTYLE_FLAT | TBSTYLE_TRANSPARENT) || !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0 ("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	// enable tooltips and status text
	m_wndToolBar.SetBarStyle (m_wndToolBar.GetBarStyle () | CBRS_TOOLTIPS | CBRS_FLYBY);

	/*
	// create the modules dialog bar
	if (!m_dlgModulesBar.Create (this, IDD_BAR_MODULES, CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0 ("Failed to create Modules Bar\n");
		return -1;		// fail to create
	}

	// create the banks dialog bar
	if (!m_dlgBanksBar.Create (this, IDD_BAR_BANKS, CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0 ("Failed to create Banks Bar\n");
		return -1;		// fail to create
	}
	*/

	// create the rebar control and add the tool bars and dialog bars to it
	//if (!m_wndReBar.Create(this) || !m_wndReBar.AddBar (&m_wndToolBar) || !m_wndReBar.AddBar (&m_dlgModulesBar) || !m_wndReBar.AddBar (&m_dlgBanksBar))
	if (!m_wndReBar.Create(this) || !m_wndReBar.AddBar (&m_wndToolBar))
	{
		TRACE0 ("Failed to create rebar\n");
		return -1;      // fail to create
	}

	/*
	// arrange the bands of the rebar control
	m_wndReBar.GetReBarCtrl ().MinimizeBand (0);
	m_wndReBar.GetReBarCtrl ().MinimizeBand (1);
	m_wndReBar.GetReBarCtrl ().MaximizeBand (2);
	*/

	// create the status bar and set the indicators
	if (!m_wndStatusBar.Create (this) || !m_wndStatusBar.SetIndicators (indicators, sizeof(indicators) / sizeof (UINT)))
	{
		TRACE0 ("Failed to create status bar\n");
		return -1;      // fail to create
	}

	/*
	m_dlgBanksBar.SendDlgItemMessage (IDC_BANKS, CB_ADDSTRING, 0, (LPARAM) &_T("(All Banks)"));
	m_dlgBanksBar.SendDlgItemMessage (IDC_BANKS, CB_SETCURSEL, 0, 0);

	m_dlgModulesBar.SendDlgItemMessage (IDC_MODULES, CB_ADDSTRING, 0, (LPARAM) &_T("(Default)"));
	m_dlgModulesBar.SendDlgItemMessage (IDC_MODULES, CB_SETCURSEL, 0, 0);
	*/

	return 0;
}

BOOL CMainFrame::OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	if (!m_wndSplitter.CreateStatic (this, 1, 2)) return FALSE;

	m_wndSplitter.CreateView (0, 0, RUNTIME_CLASS (CLibraryTreeView), CSize (0, 0), pContext);
	m_wndSplitter.CreateView (0, 1, RUNTIME_CLASS (CChannelListView), CSize (0, 0), pContext);

	m_pLibraryTreeView = (CLibraryTreeView *) m_wndSplitter.GetPane (0, 0);
	m_pChannelListView = (CChannelListView *) m_wndSplitter.GetPane (0, 1);

	m_wndSplitter.SetColumnInfo (0, 150, 0);
	m_wndSplitter.RecalcLayout ();

	//OnFileNew ();

	// use NULL as the context so that CFrameWnd doesn't try and make another view
	return __super::OnCreateClient (lpcs, NULL);
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	//m_pChannelListCtrl->SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	/*
	// let the view have first crack at the command
	if (m_pChannelListCtrl->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;
	*/

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnSetRange (const int nLower, const int nUpper)
{
	if (m_pTransferProgressDialog != NULL)
	{
		m_pTransferProgressDialog->m_ctrlProgress.SetRange32 (nLower, nUpper);
	}
}

void CMainFrame::OnSetPosition (const int nPosition)
{
	if (m_pTransferProgressDialog != NULL)
	{
		m_pTransferProgressDialog->m_ctrlProgress.SetPos (nPosition);
	}
}

void CMainFrame::OnTransferModules ()
{
	rlManagerModulesDlg dlg;
	dlg.DoModal ();
}

void CMainFrame::OnTransferUploadAll ()
{
	rlModule *pModule;
	m_RadioLinkManager.GetDefaultModule (&pModule);

	rlMemory *pMemory;
	HRESULT hResult = pModule->GetMemory (&pMemory);
	if (FAILED (hResult))
	{
		CString strErrorMessage;
		strErrorMessage.Format (_T("An error occured while attempting to retrieve the rlMemory interface from the selected RadioLink Module.\n\nrlModule::GetMemory () returned error code 0x%X.\n\nPlease contact the maker of this RadioLink Module for further assistance."), hResult);
		::AfxMessageBox (strErrorMessage);
		m_RadioLinkManager.ReleaseModule (pModule);
		return;
	}

	if (m_pTransferProgressDialog == NULL) delete m_pTransferProgressDialog;
	m_pTransferProgressDialog = new CTransferProgressDialog (this);
	m_pTransferProgressDialog->Create (IDD_TRANSFER_PROGRESS, this);

	pMemory->SetProgressTarget (this);

	hResult = pMemory->SetAllChannels (&m_MemoryChannelArray);
	if (FAILED (hResult))
	{
		GDDEBUGHRESULT (3, "rlMemory::SetAllChennels ()", hResult);
		::AfxMessageBox (_T("A transfer error has occurred."), MB_ICONEXCLAMATION | MB_OK);
	}

	m_pTransferProgressDialog->DestroyWindow ();
	delete m_pTransferProgressDialog;
	m_pTransferProgressDialog = NULL;

	m_RadioLinkManager.ReleaseModule (pModule);
}

void CMainFrame::OnTransferUploadSelected()
{
/*
	int nSelectedCount = m_pChannelListCtrl->GetSelectedCount ();
	if (nSelectedCount == 0)
	{
		return;
	}

	rlModule *pModule;
	m_RadioLinkManager.GetDefaultModule (&pModule);

	rlMemory *pMemory;
	HRESULT hResult = pModule->GetMemory (&pMemory);
	if (FAILED (hResult))
	{
		GDDEBUGHRESULT (3, "rlModule::GetMemory ()", hResult);

		CString strErrorMessage;
		strErrorMessage.Format (_T("An error occured while attempting to retrieve the rlMemory interface from the selected RadioLink Module.\n\nrlModule::GetMemory () returned error code 0x%X.\n\nPlease contact the maker of this RadioLink Module for further assistance."), hResult);
		::AfxMessageBox (strErrorMessage);
		m_RadioLinkManager.ReleaseModule (pModule);
		return;
	}

	if (m_pTransferProgressDialog == NULL) delete m_pTransferProgressDialog;
	m_pTransferProgressDialog = new CTransferProgressDialog (this);
	m_pTransferProgressDialog->Create (IDD_TRANSFER_PROGRESS, this);

	m_pTransferProgressDialog->m_ctrlProgress.SetRange (0, (short) nSelectedCount);

	pMemory->SetChannelMultiStart (nSelectedCount);

	int nRow = m_pChannelListCtrl->GetNextItem (-1, LVNI_SELECTED);
	int nProgress = 0;

	while (nRow != -1)
	{
		m_pTransferProgressDialog->m_ctrlProgress.SetPos (nProgress);

		if (!SUCCEEDED (pMemory->SetChannelMulti (m_MemoryChannelArray.GetAt (nRow))))
		{
			::AfxMessageBox (_T("A transfer error has occurred."), MB_ICONEXCLAMATION | MB_OK);
		}

		nRow = m_pChannelListCtrl->GetNextItem (nRow, LVNI_SELECTED);
		nProgress++;
	}

	pMemory->SetChannelMultiEnd ();

	m_pTransferProgressDialog->DestroyWindow ();
	delete m_pTransferProgressDialog;
	m_pTransferProgressDialog = NULL;

	m_RadioLinkManager.ReleaseModule (pModule);
*/
}

/*
void CMainFrame::OnFileOpen()
{
	CFileDialog dlgOpen (TRUE, "csv", NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, _T("Delimited Text File (*.csv, *.txt)|*.csv;*.txt|All Files (*.*)|*.*||"), this);

	if (dlgOpen.DoModal () != IDOK) return;

	m_strFileName = dlgOpen.GetPathName ();

	CTable ChannelDataTable;
	CDelimitedTextFile dtfTextFile (&ChannelDataTable);
	if (!dtfTextFile.LoadFile (&m_strFileName))
	{
		::AfxMessageBox (_T("The file could not be opened.\n"), MB_ICONEXCLAMATION | MB_OK);
	}

	//CDelimitedTextFileImportDlg dlgImport;
	//dlgImport.SetDataTable (&ChannelDataTable);
	//dlgImport.DoModal ();

	m_pChannelListCtrl->SetRedraw (FALSE);
	m_pChannelListCtrl->DeleteAllItems ();

	CString strTemp;

	for (int nRow = 0; nRow < ChannelDataTable.GetRowCount () - 1; nRow++)
	{
		m_pChannelListCtrl->InsertItem (nRow, NULL);

		for (int nColumn = 0; nColumn < ChannelDataTable.GetColumnCount (); nColumn++)
		{
			strTemp = ChannelDataTable.GetCell (nRow + 1, nColumn)->GetDataString ();
			SetItemString (nRow, nColumn, strTemp);
		}
	}

	m_pChannelListCtrl->SetRedraw (TRUE);
}

void CMainFrame::OnFileSave()
{
	if (m_strFileName.IsEmpty ())
	{
		OnFileSaveAs ();
		return;
	}

	CTable ChannelDataTable;

	ChannelDataTable.AddColumn (7);
	ChannelDataTable.AddRow (m_pChannelListCtrl->GetItemCount () + 1);

	CTableCell cellID (_T("ID"));
	CTableCell cellFrequency (_T("Frequency"));
	CTableCell cellDescription (_T("Description"));
	CTableCell cellNumber (_T("Car Number"));
	CTableCell cellDelay (_T("Delay"));
	CTableCell cellLockout (_T("Lockout"));
	CTableCell cellPriority (_T("Priority"));

	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_NUMBER, &cellID);
	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_FREQUENCY, &cellFrequency);
	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_DESCRIPTION, &cellDescription);
	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_CARNUMBER, &cellNumber);
	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_DELAY, &cellDelay);
	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_LOCKOUT, &cellLockout);
	ChannelDataTable.SetCell (0, CHANNEL_LIST_COLUMN_PRIORITY, &cellPriority);

	CString strItemString;
	CTableCell CellData;

	for (int nRow = 0; nRow < m_pChannelListCtrl->GetItemCount (); nRow++)
	{
		for (int nColumn = 0; nColumn < ChannelDataTable.GetColumnCount (); nColumn++)
		{
			strItemString = GetItemString (nRow, nColumn);

			if (nColumn == CHANNEL_LIST_COLUMN_CARNUMBER)
			{
				CellData.SetData (&strItemString);
			}
			else
			{
				CellData.SetDataAutoType (&strItemString);
			}
			
			ChannelDataTable.SetCell (nRow + 1, nColumn, &CellData);
		}
	}

	CDelimitedTextFile dtfTextFile (&ChannelDataTable);
	if (!dtfTextFile.SaveFile (&m_strFileName))
	{
		::AfxMessageBox (_T("The file could not be saved.\n"), MB_ICONEXCLAMATION | MB_OK);
	}
}

void CMainFrame::OnFileSaveAs()
{
	CFileDialog dlgSaveAs (FALSE, "csv", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Delimited Text File (*.csv, *.txt)|*.csv;*.txt|All Files (*.*)|*.*||"), this);
	
	if (dlgSaveAs.DoModal () != IDOK) return;

	m_strFileName = dlgSaveAs.GetPathName ();

	OnFileSave ();
}
*/

void CMainFrame::OnViewDebugMessages()
{
	gdGetDebug ()->ShowDebugMessagesDialog (this);
}

void CMainFrame::OnEditDelete()
{
/*
	m_pChannelListCtrl->SetRedraw (FALSE);

	rlMemoryChannel *pMemoryChannel;

	for (int nItem = 0; nItem < m_pChannelListCtrl->GetItemCount (); nItem++)
	{
		if (m_pChannelListCtrl->GetItemState (nItem, LVIS_SELECTED))
		{
			pMemoryChannel = m_MemoryChannelArray.GetAt (nItem);

			pMemoryChannel->Empty ();
			pMemoryChannel->SetChannelNumber (nItem + 1);
		}
	}

	m_pChannelListCtrl->SetRedraw (TRUE);
	m_pChannelListCtrl->Invalidate ();
*/
}

void CMainFrame::OnUpdateUIItemSelected (CCmdUI * /*pCmdUI*/)
{
	/*
	bool bItemSelected = false;

	for (int nItem = 0; nItem < m_pChannelListCtrl->GetItemCount (); nItem++)
	{
		if (m_pChannelListCtrl->GetItemState (nItem, LVIS_SELECTED))
		{
			bItemSelected = true;
			break;
		}
	}

	if (bItemSelected)
	{
		pCmdUI->Enable (TRUE);
	}
	else
	{
		pCmdUI->Enable (FALSE);
	}
	*/
}

void CMainFrame::OnHelpProLinkWebsite()
{
	::ShellExecute (NULL, _T("open"), _T("http://www.glyff.net/software/prolink/"), NULL, NULL, SW_SHOW);
}

void CMainFrame::OnHelpInterfaceCables()
{
	::ShellExecute (NULL, _T("open"), _T("http://www.glyff.net/software/prolink/datacables/"), NULL, NULL, SW_SHOW);
}
