// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "TransparentDialogBar.h"
#include "LibraryTreeView.h"
#include "ChannelListView.h"

#include "rlManager.h"
#include "rlMemoryChannelArray.h"
#include "rlProgressTarget.h"

#include "TransferProgressDialog.h"

class CMainFrame : public CFrameWnd, rlProgressTarget
{
	public:
		CMainFrame ();

	protected: 
		DECLARE_DYNCREATE (CMainFrame)

	// Attributes
	public:

	// Operations
	public:

	// Overrides
	public:
		virtual BOOL PreCreateWindow (CREATESTRUCT& cs);
		virtual BOOL OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

		virtual void OnSetRange (const int, const int);
		virtual void OnSetPosition (const int);

	// Implementation
	public:
		virtual ~CMainFrame();
		#ifdef _DEBUG
			virtual void AssertValid() const;
			virtual void Dump(CDumpContext& dc) const;
		#endif

	protected:
		// toolbars and status bars
		CStatusBar	m_wndStatusBar;
		CToolBar	m_wndToolBar;
		CReBar		m_wndReBar;
		//CTransparentDialogBar	m_dlgModulesBar;
		//CTransparentDialogBar	m_dlgBanksBar;

		// view windows
		CSplitterWnd m_wndSplitter;
		CLibraryTreeView *m_pLibraryTreeView;
		CChannelListView *m_pChannelListView;

		// modeless dialogs
		CTransferProgressDialog *m_pTransferProgressDialog;

		// RadioLink
		rlManager	m_RadioLinkManager;
		rlMemoryChannelArray m_MemoryChannelArray;

		CString	m_strFileName;

		const CString GetItemString (const int, const int);
		void SetItemString (const int, const int, const CString);

	// Generated message map functions
	protected:
		afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
		afx_msg void OnSetFocus (CWnd *pOldWnd);

	public:
		//afx_msg void OnFileNew();
		afx_msg void OnTransferModules();
		afx_msg void OnTransferUploadAll();
		afx_msg void OnTransferUploadSelected();
		//afx_msg void OnFileOpen();
		//afx_msg void OnFileSave();
		//afx_msg void OnFileSaveAs();
		afx_msg void OnViewDebugMessages();
		afx_msg void OnEditDelete();
		afx_msg void OnUpdateUIItemSelected(CCmdUI *pCmdUI);

	DECLARE_MESSAGE_MAP()
protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
public:
	afx_msg void OnHelpInterfaceCables();
	afx_msg void OnHelpProLinkWebsite();
};


