// ProLink.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ProLink.h"
#include "MainFrm.h"

#include "ProLinkDocument.h"
#include "ChannelListView.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CProLinkApp

BEGIN_MESSAGE_MAP(CProLinkApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)

	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)

	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)

END_MESSAGE_MAP()


// CProLinkApp construction

CProLinkApp::CProLinkApp()
{
	EnableHtmlHelp();

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CProLinkApp object

CProLinkApp theApp;

// CProLinkApp initialization

BOOL CProLinkApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	SetRegistryKey(_T("Glyff Computer Services"));

	/*
	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object
	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;
	// create and load the frame with its resources
	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);
	*/

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate *pDocTemplate;
	pDocTemplate = new CSingleDocTemplate (
		IDR_MAINFRAME,
		RUNTIME_CLASS (CProLinkDocument),
		RUNTIME_CLASS (CMainFrame),
		RUNTIME_CLASS (CChannelListView));
	AddDocTemplate (pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen ();
	RegisterShellFileTypes (TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine (cmdInfo);

	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand (cmdInfo)) return FALSE;

	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow (SW_SHOW);
	m_pMainWnd->UpdateWindow ();

	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand

	return TRUE;
}


// CProLinkApp message handlers



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
	public:
		CAboutDlg();

		// Dialog Data
		enum { IDD = IDD_ABOUTBOX };

	protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
	protected:
		DECLARE_MESSAGE_MAP()

	public:
		virtual BOOL OnInitDialog();
		afx_msg void OnStnClickedUrlProLinkHome();
		afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
		afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

		afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_STN_CLICKED (IDC_URL_PROLINK_HOME, OnStnClickedUrlProLinkHome)
	ON_WM_CTLCOLOR()
	ON_WM_SETCURSOR()
	ON_WM_DRAWITEM()
END_MESSAGE_MAP()

// App command to run the dialog
void CProLinkApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CProLinkApp message handlers


BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	LOGFONT lfVersionCtrlFont;
	HFONT hfontVersionCtrlFont;
	GetFont ()->GetLogFont (&lfVersionCtrlFont);
	hfontVersionCtrlFont = ::CreateFont (22, lfVersionCtrlFont.lfWidth, lfVersionCtrlFont.lfEscapement, lfVersionCtrlFont.lfOrientation, FW_BOLD, lfVersionCtrlFont.lfItalic, lfVersionCtrlFont.lfUnderline, lfVersionCtrlFont.lfStrikeOut, lfVersionCtrlFont.lfCharSet, lfVersionCtrlFont.lfOutPrecision, lfVersionCtrlFont.lfClipPrecision, lfVersionCtrlFont.lfQuality, lfVersionCtrlFont.lfPitchAndFamily, lfVersionCtrlFont.lfFaceName);
	::PostMessage (GetDlgItem (IDC_TEXT_VERSION)->m_hWnd, WM_SETFONT, (WPARAM) hfontVersionCtrlFont, false);

	LOGFONT lfUrlCtrlFont;
	HFONT hfontUrlCtrlFont;
	GetFont ()->GetLogFont (&lfUrlCtrlFont);
	hfontUrlCtrlFont = ::CreateFont (lfUrlCtrlFont.lfHeight, lfUrlCtrlFont.lfWidth, lfUrlCtrlFont.lfEscapement, lfUrlCtrlFont.lfOrientation, lfUrlCtrlFont.lfWeight, lfUrlCtrlFont.lfItalic, true, lfUrlCtrlFont.lfStrikeOut, lfUrlCtrlFont.lfCharSet, lfUrlCtrlFont.lfOutPrecision, lfUrlCtrlFont.lfClipPrecision, lfUrlCtrlFont.lfQuality, lfUrlCtrlFont.lfPitchAndFamily, lfUrlCtrlFont.lfFaceName);
	::PostMessage (GetDlgItem (IDC_URL_PROLINK_HOME)->m_hWnd, WM_SETFONT, (WPARAM) hfontUrlCtrlFont, false);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::OnStnClickedUrlProLinkHome()
{
	::ShellExecute (AfxGetMainWnd ()->m_hWnd, _T("open"), _T("http://www.glyff.net/software/prolink/"), NULL, NULL, SW_SHOWNORMAL);
}

HBRUSH CAboutDlg::OnCtlColor (CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hBrush = CDialog::OnCtlColor (pDC, pWnd, nCtlColor);
	
	if (nCtlColor == CTLCOLOR_STATIC)
	{
		int CtlId = pWnd->GetDlgCtrlID ();

		if (CtlId == IDC_URL_PROLINK_HOME)
		{
			// TODO: get the proper color from IE - HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Settings\Anchor Color
			pDC->SetTextColor (RGB (0x00, 0x00, 0xC0));
		}
	}

	return hBrush;
}

BOOL CAboutDlg::OnSetCursor (CWnd* pWnd, UINT nHitTest, UINT message)
{
	int CtlId = pWnd->GetDlgCtrlID ();

	if (CtlId == IDC_URL_PROLINK_HOME)
	{
		::SetCursor (AfxGetApp ()->LoadCursor (IDC_HAND));
		return true;
	}
	else
	{
		return CDialog::OnSetCursor(pWnd, nHitTest, message);
	}
}

void CAboutDlg::OnDrawItem (int /*nIDCtl*/, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC DC;
	DC.Attach (lpDrawItemStruct->hDC);

	DC.FillSolidRect (&lpDrawItemStruct->rcItem, 0x00000000);

	//CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}
