// ProLinkDocument.cpp : implementation file
//

#include "stdafx.h"
#include "ProLink.h"
#include "ProLinkDocument.h"


// CProLinkDocument

IMPLEMENT_DYNCREATE(CProLinkDocument, CDocument)

CProLinkDocument::CProLinkDocument()
{
	m_pCurrentChannelList = NULL;

	CreateLibraryRoot ();
}

CProLinkDocument::~CProLinkDocument()
{
	DeleteAllChannelLists ();

	delete m_pLibraryRoot;
}

BEGIN_MESSAGE_MAP(CProLinkDocument, CDocument)
END_MESSAGE_MAP()

// CProLinkDocument diagnostics

#ifdef _DEBUG
void CProLinkDocument::AssertValid() const
{
	CDocument::AssertValid();
}

void CProLinkDocument::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


BOOL CProLinkDocument::OnNewDocument()
{
	if (!CDocument::OnNewDocument ()) return FALSE;

	DeleteAllChannelLists ();

	rlMemoryChannelArray *pNewChannelList = NewChannelList (GetLibraryRoot (), _T("Untitled Channel List"));
	m_pCurrentChannelList = pNewChannelList;

	SetModifiedFlag (FALSE);

	return TRUE;
}

// CProLinkDocument serialization

void CProLinkDocument::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


// CProLinkDocument commands

CLibraryFolder *CProLinkDocument::CreateLibraryRoot (void)
{
	m_pLibraryRoot = DEBUG_NEW CLibraryFolder (0, _T("Library"));

	return m_pLibraryRoot;
}

CLibraryFolder *CProLinkDocument::GetLibraryRoot (void)
{
	return m_pLibraryRoot;
}

rlMemoryChannelArray *CProLinkDocument::GetCurrentChannelList (void)
{
	return m_pCurrentChannelList;
}

rlMemoryChannelArray *CProLinkDocument::NewChannelList (CLibraryFolder *pParentFolder, CString strName)
{
	/*CLibraryItem *pNewItem =*/ pParentFolder->CreateChildItem (strName);

	rlMemoryChannelArray *pNewChannelList = DEBUG_NEW rlMemoryChannelArray;
	m_colChannelLists.Add (pNewChannelList);

	SetModifiedFlag ();
	UpdateAllViews (NULL);

	return pNewChannelList;
}

void CProLinkDocument::DeleteAllChannelLists (void)
{
	for (int x = 0; x < m_colChannelLists.GetCount (); x++)
	{
		delete m_colChannelLists.GetAt (x);
	}

	m_colChannelLists.RemoveAll ();

	m_pLibraryRoot->DeleteAllChildItems ();
}
