#pragma once

#include "LibraryFolder.h"
#include "rlMemoryChannelArray.h"

// CProLinkDocument document

class CProLinkDocument : public CDocument
{
	DECLARE_DYNCREATE(CProLinkDocument)

	public:
		CProLinkDocument();
		virtual ~CProLinkDocument();
		virtual void Serialize(CArchive& ar);   // overridden for document i/o
		#ifdef _DEBUG
			virtual void AssertValid() const;
			virtual void Dump(CDumpContext& dc) const;
		#endif

		CLibraryFolder *CreateLibraryRoot (void);
		CLibraryFolder *GetLibraryRoot (void);
		rlMemoryChannelArray *GetCurrentChannelList (void);

		rlMemoryChannelArray *NewChannelList (CLibraryFolder *, CString);
		void DeleteAllChannelLists (void);

	protected:
		virtual BOOL OnNewDocument();

		CLibraryFolder *m_pLibraryRoot;

		CArray <rlMemoryChannelArray *> m_colChannelLists;
		rlMemoryChannelArray *m_pCurrentChannelList;

	DECLARE_MESSAGE_MAP()
};
