#pragma once

enum GD_GRIDCTRL_ITEM_TYPE
{
	Text,
	CheckBox,
	ComboBox,
};

struct GD_GRIDCTRL_ITEM_DATA
{
	int bEnabled;

	COLORREF crText;
	COLORREF crBackground;

	bool bBold;
	bool bItalic;
	bool bUnderline;
	bool bStrikeOut;

	GD_GRIDCTRL_ITEM_TYPE ItemType;
	 
	int nCheckedState;
};

// gdGridCtrl

class gdGridCtrl : public CListCtrl
{
	DECLARE_DYNCREATE(gdGridCtrl)

	public:
		gdGridCtrl();
		virtual ~gdGridCtrl();

		virtual BOOL Create(DWORD, const RECT&, CWnd*, UINT);
		HRESULT EditItem(const int, const int, CEdit ** = NULL);

		const int GetNextItemUp (const int);
		const int GetNextItemDown (const int, const bool = false);
		const int GetNextSubItemLeft (const int);
		const int GetNextSubItemRight (const int);

		void SelectItem(int nItem, bool bDeselectOthers);

	protected:
		DECLARE_MESSAGE_MAP()

	public:
		afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
		afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
		afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
		afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
		afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
		afx_msg BOOL OnEndLabelEdit(NMHDR *pNMHDR, LRESULT *pResult);
		afx_msg void OnEditSelectAll();
		afx_msg BOOL OnEditDelete(UINT);

};


