// Manager.cpp : Implementation of CManager

#include "stdafx.h"
#include "atlsafe.h"
#include "Manager.h"


// CManager


STDMETHODIMP CManager::RegisterModule(BSTR ModuleId, BSTR ClassID)
{
	return E_NOTIMPL;
}

STDMETHODIMP CManager::UnRegisterModule(BSTR ModuleId)
{
	return E_NOTIMPL;
}

STDMETHODIMP CManager::GetModule(BSTR ModuleId, IModule **pModule)
{
	CLSID ModuleCLSID = GetModuleCLSID (ModuleId);

	::CoCreateInstance (ModuleCLSID, NULL, CLSCTX_ALL, __uuidof (IModule), (LPVOID *) *pModule);

	return S_OK;
}

STDMETHODIMP CManager::ReleaseModule(IModule *pModule)
{
	pModule->Release ();

	return S_OK;
}

STDMETHODIMP CManager::get_DefaultModule(BSTR *pVal)
{
	CRegKey regModules;
	regModules.Open (HKEY_LOCAL_MACHINE, _T("\\SOFTWARE\\Glyff Computer Services\\RadioLink\\Modules"));

	LONG lResult;

	ULONG uLength;
	lResult = regModules.QueryStringValue (NULL, NULL, &uLength);

	LPTSTR pDefaultModuleId = new TCHAR [uLength];
	lResult = regModules.QueryStringValue (NULL, pDefaultModuleId, &uLength);

	CComBSTR strDefaultModuleId (pDefaultModuleId);
	strDefaultModuleId.CopyTo (pVal);

	delete pDefaultModuleId;

	return S_OK;
}

STDMETHODIMP CManager::put_DefaultModule(BSTR newVal)
{
	CRegKey regModules;
	regModules.Open (HKEY_LOCAL_MACHINE, _T("\\SOFTWARE\\Glyff Computer Services\\RadioLink\\Modules"));

	regModules.SetStringValue (NULL, CW2T (newVal));

	return S_OK;
}

STDMETHODIMP CManager::get_Modules(SAFEARRAY **pVal)
{
	LONG lResult;

	CRegKey regModules;
	lResult = regModules.Open (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Glyff Computer Services\\RadioLink\\Modules"));

	CComSafeArray <BSTR> ModulesArray;

	TCHAR pKeyName [256];
	DWORD dwLength;

	int x = 0;
	bool bFinished = false;

	while (!bFinished)
	{
		dwLength = 256;
		lResult = regModules.EnumKey (x, pKeyName, &dwLength);

		if (lResult == ERROR_NO_MORE_ITEMS)
		{
			bFinished = TRUE;
		}
		else
		{
			ModulesArray.Add (CComBSTR (pKeyName));
			x++;
		}
	}

	ModulesArray.CopyTo (pVal);

	return S_OK;
}

STDMETHODIMP CManager::ShowConfigurationDialog(HWND Parent)
{
	return E_NOTIMPL;
}

CLSID CManager::GetModuleCLSID (BSTR ModuleId)
{
	CRegKey regModules;
	regModules.Open (HKEY_LOCAL_MACHINE, _T("\\SOFTWARE\\Glyff Computer Services\\RadioLink\\Modules"));

	CRegKey regRequestedModule;
	regRequestedModule.Open (regModules, CW2T (ModuleId));

	GUID ModuleCLSID;
	regRequestedModule.QueryGUIDValue (_T("CLSID"), ModuleCLSID);

	return ModuleCLSID;
}
