// Manager.h : Declaration of the CManager

#pragma once
#include "RadioLink.h"
#include "resource.h"


// IManager
[
	object,
	uuid("4969AD17-5C8F-476B-921E-D1E7B2D8C164"),
	dual,
	helpstring("IManager Interface"),
	pointer_default(unique)
]
__interface IManager : IDispatch
{
	[id(1), helpstring("method RegisterModule")] HRESULT RegisterModule([in] BSTR ModuleId, [in] BSTR ClassID);
	[id(2), helpstring("method UnRegisterModule")] HRESULT UnRegisterModule([in] BSTR ModuleId);
	[id(3), helpstring("method GetModule")] HRESULT GetModule([in] BSTR ModuleId, [out, retval] IModule **pModule);
	[id(4), helpstring("method ReleaseModule")] HRESULT ReleaseModule([in] IModule *pModule);
	[propget, id(5), helpstring("property DefaultModule")] HRESULT DefaultModule([out, retval] BSTR *pVal);
	[propput, id(5), helpstring("property DefaultModule")] HRESULT DefaultModule([in] BSTR newVal);
	[propget, id(6), helpstring("property Modules")] HRESULT Modules([out, retval, satype (BSTR)] SAFEARRAY **pVal);
	[id(7), helpstring("method ShowConfigurationDialog")] HRESULT ShowConfigurationDialog([in] HWND Parent);
};


// CManager

[
	coclass,
	threading("apartment"),
	vi_progid("RadioLink.Manager"),
	progid("RadioLink.Manager.1"),
	version(1.0),
	uuid("9DB7B047-CCE5-4783-B3E6-55C293B7A388"),
	helpstring("Manager Class")
]
class ATL_NO_VTABLE CManager : 
	public IManager
{
	public:
		CManager()
		{
		}


		DECLARE_PROTECT_FINAL_CONSTRUCT()

		HRESULT FinalConstruct()
		{
			return S_OK;
		}
		
		void FinalRelease() 
		{
		}

	public:
		STDMETHOD(RegisterModule)(BSTR, BSTR);
		STDMETHOD(UnRegisterModule)(BSTR);
		STDMETHOD(GetModule)(BSTR, IModule **);
		STDMETHOD(ReleaseModule)(IModule *);
		STDMETHOD(get_DefaultModule)(BSTR *);
		STDMETHOD(put_DefaultModule)(BSTR);
		STDMETHOD(get_Modules)(SAFEARRAY **);
		STDMETHOD(ShowConfigurationDialog)(HWND);

	protected:
		CLSID GetModuleCLSID (BSTR);

};

