Public Class frmSerialTest
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtReceive As System.Windows.Forms.TextBox
    Friend WithEvents txtSend As System.Windows.Forms.TextBox
    Friend WithEvents btnSend As System.Windows.Forms.Button
    Friend WithEvents cboPorts As System.Windows.Forms.ComboBox
    Friend WithEvents btnConnect As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtReceive = New System.Windows.Forms.TextBox()
        Me.txtSend = New System.Windows.Forms.TextBox()
        Me.btnSend = New System.Windows.Forms.Button()
        Me.cboPorts = New System.Windows.Forms.ComboBox()
        Me.btnConnect = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'txtReceive
        '
        Me.txtReceive.Font = New System.Drawing.Font("Courier New", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtReceive.Location = New System.Drawing.Point(8, 40)
        Me.txtReceive.Multiline = True
        Me.txtReceive.Name = "txtReceive"
        Me.txtReceive.ReadOnly = True
        Me.txtReceive.Size = New System.Drawing.Size(512, 256)
        Me.txtReceive.TabIndex = 0
        Me.txtReceive.TabStop = False
        Me.txtReceive.Text = ""
        '
        'txtSend
        '
        Me.txtSend.AcceptsReturn = True
        Me.txtSend.Enabled = False
        Me.txtSend.Location = New System.Drawing.Point(8, 304)
        Me.txtSend.Name = "txtSend"
        Me.txtSend.Size = New System.Drawing.Size(432, 20)
        Me.txtSend.TabIndex = 1
        Me.txtSend.Text = ""
        '
        'btnSend
        '
        Me.btnSend.Enabled = False
        Me.btnSend.Location = New System.Drawing.Point(448, 304)
        Me.btnSend.Name = "btnSend"
        Me.btnSend.Size = New System.Drawing.Size(72, 24)
        Me.btnSend.TabIndex = 2
        Me.btnSend.Text = "Send"
        '
        'cboPorts
        '
        Me.cboPorts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboPorts.Location = New System.Drawing.Point(8, 8)
        Me.cboPorts.Name = "cboPorts"
        Me.cboPorts.Size = New System.Drawing.Size(184, 21)
        Me.cboPorts.TabIndex = 3
        '
        'btnConnect
        '
        Me.btnConnect.Location = New System.Drawing.Point(200, 8)
        Me.btnConnect.Name = "btnConnect"
        Me.btnConnect.Size = New System.Drawing.Size(72, 24)
        Me.btnConnect.TabIndex = 4
        Me.btnConnect.Text = "Connect"
        '
        'frmSerialTest
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(528, 334)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnConnect, Me.cboPorts, Me.btnSend, Me.txtSend, Me.txtReceive})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.Name = "frmSerialTest"
        Me.Text = "gdSerial Test Program"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim WithEvents SerialLink As gdSerial.CSerialLink
    Dim IsConnected As Boolean = False

    Private Sub frmSerialTest_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            Dim SerialPortInfo As gdSerial.CSerialPortInfo = New gdSerial.CSerialPortInfo()
            Dim PortCount As Integer = SerialPortInfo.AvailablePortNames.GetUpperBound(0)
            Dim Port As Integer
            Dim PortName As String
            Dim PortFriendlyName As String
            Dim PortDescription As String

            For Port = 0 To PortCount
                PortName = SerialPortInfo.AvailablePortNames(Port)
                PortFriendlyName = SerialPortInfo.PortFriendlyName(PortName)
                PortDescription = SerialPortInfo.PortDescription(PortName)

                cboPorts.Items.Add(PortFriendlyName & " - " & PortDescription)
            Next Port

            cboPorts.SelectedIndex = 0

            SerialLink = New gdSerial.CSerialLink()
        Catch ex As System.Runtime.InteropServices.COMException
            MsgBox("An error occurred.  Error code: " & ex.ErrorCode, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
        End Try
    End Sub

    Private Sub frmSerialTest_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        If (IsConnected) Then
            Try
                SerialLink.ClosePort()
            Catch ex As System.Runtime.InteropServices.COMException
                MsgBox("An error occurred.  Error code: " & ex.ErrorCode, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            End Try
        End If

        SerialLink = Nothing
    End Sub

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Dim SendText As String = txtSend.Text & Chr(&HD) '& Chr(&HA)
        'Dim SendText As String = "AT" & Chr(&HD)

        Try
            SerialLink.SendDataString(SendText)
        Catch ex As System.Runtime.InteropServices.COMException
            MsgBox("An error occurred.  Error code: " & ex.ErrorCode, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
        End Try

        txtSend.Text = ""
    End Sub

    Private Sub SerialLink_OnReceiveDataString(ByVal Data As String) Handles SerialLink.OnReceiveDataString
        txtReceive.AppendText(Data)
    End Sub

    Private Sub txtSend_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtSend.KeyPress
        If e.KeyChar = ChrW(&HD) Then
            Dim Arguments As EventArgs
            btnSend_Click(Me, Arguments)
            e.Handled = True
        End If
    End Sub

    Private Sub SerialLink_OnError(ByVal ErrorCode As Integer) Handles SerialLink.OnError
        txtReceive.AppendText(ChrW(&HD) & ChrW(&HA) & "Communications Error: ErrorCode = " & ErrorCode & ChrW(&HD) & ChrW(&HA))
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        If (IsConnected) Then
            Try
                SerialLink.ClosePort()
            Catch ex As System.Runtime.InteropServices.COMException
                MsgBox("An error occurred.  Error code: " & ex.ErrorCode, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            End Try

            btnConnect.Text = "Connect"
            txtSend.Enabled = False
            btnSend.Enabled = False

            IsConnected = False
        Else
            Try
                Dim SerialPortInfo As gdSerial.CSerialPortInfo = New gdSerial.CSerialPortInfo()

                SerialLink.PortName = SerialPortInfo.AvailablePortNames(cboPorts.SelectedIndex)
                SerialLink.PortSpeed = 19200
                SerialLink.PortStopBits = 1

                SerialLink.OpenPort()

            Catch ex As System.Runtime.InteropServices.COMException
                MsgBox("An error occurred.  Error code: " & ex.ErrorCode, MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly)
            End Try

            btnConnect.Text = "Disconnect"
            txtSend.Enabled = True
            btnSend.Enabled = True

            IsConnected = True
        End If
    End Sub
End Class
