// SerialPortInfo.cpp : Implementation of CSerialPortInfo

#include "stdafx.h"
#include "atlsafe.h"
#include "SerialPortInfo.h"

#ifndef GUID_CLASS_COMPORT
DEFINE_GUID (GUID_CLASS_COMPORT, 0x86e0d1e0L, 0x8089, 0x11d0, 0x9c, 0xe4, 0x08, 0x00, 0x3e, 0x30, 0x1f, 0x73);
#endif

// CSerialPortInfo

STDMETHODIMP CSerialPortInfo::get_AvailablePortNames(SAFEARRAY **pVal)
{
	/*
	CComSafeArray <BSTR> saPortList;
	HRESULT hResult;

	OSVERSIONINFO VersionInfo;
	::GetVersionEx (&VersionInfo);

	switch (VersionInfo.dwPlatformId)
	{
		case VER_PLATFORM_WIN32s:
			// Win32s on Windows 3.1
			hResult = E_FAIL; // not supported

		case VER_PLATFORM_WIN32_WINDOWS:
			// Windows 95, 98 or Me
			hResult = GetAvailablePortNamesWin9x (*pVal);

		case VER_PLATFORM_WIN32_NT:
			// Windows NT, 2000, XP or higher
			if (VersionInfo.dwMajorVersion < 5)
			{
				// Windows NT 3.51 or 4.0
				hResult = GetAvailablePortNamesWinNT (*pVal);
			}
			else
			{
				// Windows 2000 or higher
				hResult = GetAvailablePortNames (*pVal);
			}

		default:
			hResult = GetAvailablePortNames (*pVal);

	}
	*/

	CComSafeArray <BSTR> saPortList;

	int nBufferSize = 256;
	BSTR strBuffer = new WCHAR [nBufferSize];

	for (int x = 1; x <= 32; x++)
	{
		_snwprintf (strBuffer, nBufferSize, L"\\\\.\\COM%d", x);
		saPortList.Add (strBuffer);
	}

	saPortList.CopyTo (pVal);

	return S_OK;
}

STDMETHODIMP CSerialPortInfo::get_PortFriendlyName (BSTR PortName, BSTR *pVal)
{
	CStringW strPortName (PortName);
	CStringW strFriendlyName;

	int nLastBackslash = strPortName.ReverseFind (L'\\');

	if (nLastBackslash == -1)
	{
		strFriendlyName = strPortName;
	}
	else
	{
		strFriendlyName = strPortName.Right (strPortName.GetLength () - nLastBackslash - 1);
	}

	CComBSTR bstrFriendlyName (strFriendlyName);
	bstrFriendlyName.CopyTo (pVal);

	return S_OK;
}

STDMETHODIMP CSerialPortInfo::get_PortDescription (BSTR /*PortName*/, BSTR *pVal)
{
	CComBSTR strPortDescription (L"Serial Port");
	strPortDescription.CopyTo (pVal);

	return S_OK;
}

HRESULT CSerialPortInfo::GetAvailablePortNames (SAFEARRAY * /*pPortList*/)
{
	return E_NOTIMPL;
}

HRESULT CSerialPortInfo::GetAvailablePortNamesWin9x (SAFEARRAY * /*pPortList*/)
{
	return E_NOTIMPL;
}

HRESULT CSerialPortInfo::GetAvailablePortNamesWinNT (SAFEARRAY *pPortList)
{
	CComSafeArray <BSTR> saPortList (pPortList);

	int nBufferSize = 256;
	BSTR strBuffer = new WCHAR [nBufferSize];

	for (int x = 1; x <= 32; x++)
	{
		_snwprintf (strBuffer, nBufferSize, L"\\\\.\\COM%d", x);
		saPortList.Add (strBuffer);
	}

	return S_OK;
}
