// SerialPortInfo.h : Declaration of the CSerialPortInfo

#pragma once
#include "resource.h"       // main symbols


// ISerialPortInfo
[
	object,
	uuid("C8620A59-C587-40D6-A618-701A87B9A90A"),
	dual,
	helpstring("ISerialPortInfo Interface"),
	pointer_default(unique),
]
__interface ISerialPortInfo : IDispatch
{
	[propget, id(1), helpstring("property AvailablePorts")] HRESULT AvailablePortNames([out, retval, satype (BSTR)] SAFEARRAY **pVal);
	[propget, id(2), helpstring("property PortFriendlyName")] HRESULT PortFriendlyName([in] BSTR PortName, [out, retval] BSTR *pVal);
	[propget, id(3), helpstring("property PortDescription")] HRESULT PortDescription([in] BSTR PortName, [out, retval] BSTR *pVal);
};


// CSerialPortInfo

[
	coclass,
	threading("apartment"),
	vi_progid("gdSerial.SerialPortInfo"),
	progid("gdSerial.SerialPortInfo.1"),
	version(1.0),
	uuid("9D817564-CBBA-412D-9C21-8FC2FAA624CC"),
	helpstring("SerialPortInfo Class"),
	default(ISerialPortInfo),
]
class ATL_NO_VTABLE CSerialPortInfo : public ISerialPortInfo
{
	public:
		CSerialPortInfo()
		{
		}

		DECLARE_PROTECT_FINAL_CONSTRUCT()

		HRESULT FinalConstruct()
		{
			return S_OK;
		}
		
		void FinalRelease() 
		{
		}

	public:
		STDMETHOD(get_AvailablePortNames)(SAFEARRAY **pVal);
		STDMETHOD(get_PortFriendlyName)(BSTR PortName, BSTR *pVal);
		STDMETHOD(get_PortDescription)(BSTR PortName, BSTR *pVal);

	protected:
		HRESULT GetAvailablePortNames (SAFEARRAY *pPortList);
		HRESULT GetAvailablePortNamesWin9x (SAFEARRAY *pPortList);
		HRESULT GetAvailablePortNamesWinNT (SAFEARRAY *pPortList);

};
