// gdSerial.cpp : Implementation of WinMain

#include "stdafx.h"
#include "resource.h"

#include "InternalEventSource.h"

CInternalEventSource G_EVENTSOURCE;

// The module attribute causes WinMain to be automatically implemented for you
[ module(EXE, uuid = "{49BC15A9-B105-4700-A446-D80A5565AFA3}", 
		 name = "gdSerial", 
		 helpstring = "gdSerial 1.0 Type Library",
		 resource_name = "IDR_GDSERIAL") ]
class CSerialModule
{
	public:
		#ifdef _DEBUG
			int	WinMain(int nShowCmd);
		#endif
		void RunMessageLoop();
};

#ifdef _DEBUG
int CSerialModule::WinMain(int nShowCmd)
{
	_CrtSetDbgFlag (_CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_CHECK_CRT_DF | _CRTDBG_DELAY_FREE_MEM_DF | _CRTDBG_LEAK_CHECK_DF);

	return CAtlExeModuleT <CSerialModule>::WinMain (nShowCmd);
}
#endif

void CSerialModule::RunMessageLoop()
{
	ATLTRACE ("CSerialModule::RunMessageLoop\n");

	int nEventCount;

	bool bRunning = true;
	MSG Message;
	DWORD dwReturn;

	while (bRunning)
	{
		if (FAILED (G_EVENTSOURCE.RaisePreEventWait ()))
		{
			ATLTRACE ("WARNING: RaisePreEventWait failed\n");
		}

		nEventCount = G_EVENTSOURCE.GetEventCount ();
		dwReturn = ::MsgWaitForMultipleObjects (nEventCount, G_EVENTSOURCE.GetEvents (), FALSE, INFINITE, QS_ALLEVENTS);
		if (dwReturn == (WAIT_OBJECT_0 + nEventCount)) // windows message
		{
			if (::PeekMessage (&Message, 0, 0, 0, PM_REMOVE) == TRUE)
			{
				if (Message.message == WM_QUIT)
				{
					ATLTRACE ("Received WM_QUIT\n");
					bRunning = false;
				}
				::TranslateMessage (&Message);
				::DispatchMessage (&Message);
			}
		}
		else if ((dwReturn >= WAIT_OBJECT_0) && (dwReturn < (WAIT_OBJECT_0 + nEventCount))) // one of our events
		{
			int nEventIndex = dwReturn - WAIT_OBJECT_0;

			if (FAILED (G_EVENTSOURCE.RaiseEvent (nEventIndex)))
			{
				ATLTRACE ("WARNING: RaiseEvent failed\n");
			}
		}
		else // other
		{
			ATLTRACE ("MsgWaitForMultipleObjects returned an unknown result\n");
		}
	}
}
